#include "ParamInteger.h"
#include "Utils.h"

namespace ffgl
{

ParamInteger::ParamInteger( const std::string& name, int defaultValue, const RangeStruct range ) :
	ParamRange( name, ParameterType::FF_TYPE_INTEGER, static_cast< float >( defaultValue ), range )
{
}

ParamInteger::ParamInteger( const std::string& name, const std::string& uniformName, int defaultValue, const RangeStruct range ) :
	ParamRange( name, ParameterType::FF_TYPE_INTEGER, uniformName, static_cast< float >( defaultValue ), range )
{
}

ParamInteger::~ParamInteger()
{
}

const std::string& ParamInteger::GetDisplay() const
{
	static std::string displayString;
	displayString = std::to_string( GetIntegerValue() );
	return displayString;
}

int ParamInteger::GetIntegerValue() const
{
	return static_cast< int >( roundf( GetFloatValue() ) );
}

void ParamInteger::SetIntegerValue( int newValue )
{
	SetFloatValue( static_cast< float >( newValue ) );
}

}//End namespace ffgl